package cn.com.poc.thirdparty.resource.demand.ai.function;

import cn.com.poc.common.service.RedisService;
import cn.com.poc.common.utils.BlContext;
import cn.hutool.json.JSONObject;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class ExecuteSearchMemoryContentByEnumFunction implements AbstractExecuteLargeModelFunction{

    @Resource
    private RedisService redisService;

    @Override
    public String doMemoryFunction(String content, String useStatus, Boolean isLongMemory) {
        // 用enum给定的内容名来查询用户相关信息

        // 创建 JSONObject 对象
        JSONObject jsonObject = new JSONObject(content);
        String contentName = jsonObject.getStr("content");

        StringBuffer result = new StringBuffer();
        // 先查询变量记忆
        String key = useStatus + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + contentName;
        result.append(redisService.get(key));
        // 如果短期记忆没查到
        if(result.toString().isEmpty()){
            // 判断是否开启了长期记忆，若开启，则查询长期记忆
            if (isLongMemory) {
                String longMemoryKey = useStatus + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + "longMemory";
                result.append(redisService.get(longMemoryKey));
            }
        }
        return result.toString();
    }
}
