package cn.com.poc.thirdparty.resource.demand.ai.function;

import cn.com.poc.common.service.RedisService;
import cn.com.poc.common.utils.BlContext;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class ExecuteSearchMemoryContentFunction implements AbstractExecuteLargeModelFunction{

    @Resource
    private RedisService redisService;

    @Override
    public String doMemoryFunction(String content, String useStatus, Boolean isLongMemory) {
        // 查询用户相关信息（什么内容都可以）
        String result = null;
        // 判断是否开启了长期记忆，若开启，则查询长期记忆
        if (isLongMemory) {
            String longMemoryKey = useStatus + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + "longMemory";
            result = redisService.hmget(longMemoryKey).toString();
        }
        return result;
    }
}
