package cn.com.poc.thirdparty.resource.demand.ai.function;

import cn.com.poc.common.service.RedisService;
import cn.com.poc.common.utils.BlContext;
import cn.com.poc.common.utils.DateUtils;
import cn.hutool.json.JSONObject;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
public class ExecuteSetLongMemoryFunction implements AbstractExecuteLargeModelFunction{

    @Resource
    private RedisService redisService;

    @Override
    public String doMemoryFunction(String content, String useStatus, Boolean isLongMemory) {
        // todo 执行保存长期记忆的操作
        if(isLongMemory){
            // 创建 JSONObject 对象
            JSONObject jsonObject = new JSONObject(content);
            // 提取 content
            String contents = jsonObject.getStr("content");
            String key = useStatus + ":" + BlContext.getCurrentUserNotException().getUserId().toString() + ":" + "longMemory";
            Map<Object, Object> hmget = redisService.hmget(key);
            Map<String, Object> result = new HashMap<>();
            for (Map.Entry<Object, Object> entry : hmget.entrySet()) {
                if (entry.getKey() instanceof String) {
                    // 将 Object 强制转换为 String
                    String tempKey = (String) entry.getKey();
                    result.put(tempKey, entry.getValue());
                }
            }
            List<String> list = new ArrayList<>();
            list.add("timestamp:" + DateUtils.getCurrTime());
            list.add("content:" + contents);
            result.put(Integer.toString(hmget.size()), list);
            redisService.hmset(key, result);
        }
        return "SUCCESS";
    }
}
